#!/bin/bash
# Name: Steffen Wirth
# Homepage: http://www.pissflitsche.net/kernelscript
# Datum: 19.01.2005
trap "" 2 3
trap "" SIGTSTP
clear
echo "|------------Welcome to kernelscript 0.3.3-----------|"
echo "|                                                    |"
echo "|            ---Please select a Kernel---            |"
echo "|                                                    |"
echo "|  (1) Kernel 2.6.10              *new*         (1)  |"
echo "|  (2) Kernel 2.6.10           *oldconfig*      (2)  |"
echo "|  (3) Kernel 2.4.29                            (3)  |"
echo "|  (4) Cancel                                   (4)  |"
echo "|----------------------------------------------------|"
echo "|         - Choose a number and press Enter -        |"
echo -n "|----------------------------------------------------"
read kernel
case "$kernel" in
'1')
	clear
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-2.6.10.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-2.6.10/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-2.6.10.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-2.6.10.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xvzf linux-2.6.10.tar.gz && rm ./linux
	ln -s ./linux-2.6.10 ./linux
	cd /usr/src/linux/ && make menuconfig
	make all && make modules_install
	cp ./System.map /boot/System.map-2.6.10 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-2.6.10 &
	mkinitrd /boot/initrd-2.6.10 2.6.10 || mkinitrd || mk_initrd
	clear
	echo "|---------------------FINAL--------------------|"
	echo "|                                              |"
	echo "| Kernel: /boot/vmlinuz-2.6.10                 |"
	echo "| System: /boot/System.map-2.6.10              |"
	echo "| Initrd: /boot/initrd-2.6.10                   |"
	echo "|----------------------------------------------|"
	echo "|    Inser your new kernel in a Bootloader     |"
	echo "|      GRUB or LILO is the best choice         |"
	echo "|----------------------------------------------|"
	exit
	;;

'2')
	clear	
	rm -rf /usr/src/linux-2.6.10.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-2.6.10/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-2.6.10.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-2.6.10.tar.gz
	clear
	tar -xvzf linux-2.6.10.tar.gz && rm -rf ./linux
	ln -s ./linux-2.6.10 ./linux
	cd /usr/src/linux && zcat /proc/config.gz > .config
	make all && make modules_install || echo " Compile Error"
	rm -rf /boot/System.map-2.6.10 &
	rm -rf /boot/vmlinuz-2.6.10 &
	cp ./System.map /boot/System.map-2.6.10 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-2.6.10 &
	mkinitrd /boot/initrd-2.6.10 2.6.10 || mkinitrd || mk_initrd

	clear
	echo "|---------------------FINAL--------------------|"
	echo "|                                              |"
	echo "| Kernel: /boot/vmlinuz-2.6.10                  |"
	echo "| System: /boot/System.map-2.6.10               |"
	echo "| Initrd: /boot/initrd-2.6.10                   |"
	echo "|----------------------------------------------|"
	echo "|    Inser your new kernel in a Bootloader     |"
	echo "|      GRUB or LILO is the best choice         |"
	echo "|----------------------------------------------|"
	exit
	;;

'3')

	clear
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-2.4.29.tar.gz & 2> /dev/null
	rm -rf /usr/src/linux-2.4.29/ & 2> /dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-2.4.29.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-2.4.29.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xzf linux-2.4.29.tar.gz && rm ./linux
	ln -s ./linux-2.4.29 ./linux
	make menuconfig && make all && make modules_install || echo "Error"
	rm -rf /boot/System.map-2.4.29 & 2> /dev/null
	rm -rf /boot/vmlinuz-2.4.29 & 2> /dev/null
	cp ./System.map /boot/System.map-2.4.29 &
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-2.4.29 &
	mkinitrd /boot/initrd-2.4.29 2.4.29 || mkinitrd || mk_initrd

	clear
	echo "|---------------------FINAL--------------------|"
	echo "|                                              |"
	echo "| Kernel: /boot/vmlinuz-2.4.29                 |"
	echo "| System: /boot/System.map-2.4.29              |"
	echo "| Initrd: /boot/initrd-2.4.29                  |"
	echo "|----------------------------------------------|"
	echo "|    Inser your new kernel in a Bootloader     |"
	echo "|      GRUB or LILO is the best choice         |"
	echo "|----------------------------------------------|"
	exit
	;;
'4')
	exit
	;;
'-v')
	clear
	echo "kernelscript Version 0.3.3"
	echo "by bert2002 @ www.pissflitsche.net/kernelscript"
	;;
'--version')	
	clear
	echo "kernelscript Version 0.3.3"
	echo "by bert2002 @ www.pissflitsche.net/kernelscript"
	;;

*)
	
	echo "Please restart script and choose 1 - 2 - 3 - 4 "
esac